PRO fitscoo2healp,llon,llat,fits_header,healp_header,lon,lat

equinox_fits=sxpar(fits_header,'EQUINOX',count=count)
IF count EQ 0 THEN equinox_fits=1950.
equinox_healp=sxpar(healp_header,'EQUINOX')
IF count EQ 0 THEN equinox_healp=1950.

lon=llon & lat=llat
csys_fits=strmid(sxpar(fits_header,'CTYPE1'),0,4)
csys_healp=strtrim(sxpar(healp_header,'COORDSYS'),2)

message,'csys fits ='+csys_fits,/info
message,'csys healp='+csys_healp,/info
message,'equinox fits='+strtrim(equinox_fits,2),/info
message,'equinox healp='+strtrim(equinox_healp,2),/info

ccode=0
CASE csys_fits OF
  'RA--': BEGIN
    CASE csys_healp OF
      'E': ccode=3
      'G': ccode=1
      'C': ccode=0
    ENDCASE
  END
  'GLON': BEGIN
    CASE csys_healp OF
      'E': ccode=6
      'C': ccode=2
      'G': ccode=0
    ENDCASE
  END
  'ELON':BEGIN
    CASE csys_healp OF
      'G': ccode=5
      'C': ccode=4
      'E': ccode=0
    ENDCASE
  END
ENDCASE
message,'ccode='+strtrim(ccode,2),/info

IF ccode NE 0 THEN BEGIN
  IF csys_fits EQ 'RA--' THEN BEGIN
    IF equinox_fits NE astron_default_equinox() THEN BEGIN
      precess_array,llon,llat,equinox_fits,astron_default_equinox()
    ENDIF
  ENDIF
  euler,llon,llat,lon,lat,ccode
  IF csys_healp EQ 'C' THEN BEGIN
    IF equinox_healp NE astron_default_equinox() THEN BEGIN
      precess_array,lon,lat,astron_default_equinox(),equinox_healp
    ENDIF
  ENDIF
ENDIF ELSE BEGIN
  IF csys_healp EQ 'C' THEN BEGIN
    IF equinox_fits NE equinox_healp THEN BEGIN
      precess_array,lon,lat,equinox_fits,equinox_healp
    ENDIF
  ENDIF
ENDELSE

END
