FUNCTION next_edge_pix,naxis1,naxis2,i,j,anticlockwise=anticlockwise

; find neighboor pixel number around edge of a fits image
;default is clockwise direction

IF not keyword_set(anticlockwise) THEN BEGIN ;clockwise
  CASE i OF
    naxis1-1: BEGIN
      IF j NE 0 THEN BEGIN
        inext=i & jnext=j-1
      ENDIF ELSE BEGIN
        inext=i-1 & jnext=j
      ENDELSE
    END
    0: BEGIN
      IF j NE (naxis2-1) THEN BEGIN
        inext=i & jnext=j+1
      ENDIF ELSE BEGIN
        inext=i+1 & jnext=j
      ENDELSE  
    END
    ELSE : BEGIN
      CASE j OF
        naxis2-1: BEGIN
          IF i NE (naxis1-1) THEN BEGIN
            inext=i+1 & jnext=j
          ENDIF ELSE BEGIN
            inext=i & jnext=j-1
          ENDELSE
        END
        0: BEGIN
          IF i NE 0 THEN BEGIN
            inext=i-1 & jnext=j
          ENDIF ELSE BEGIN
            inext=i & jnext=j+1
          ENDELSE        
        END
        ELSE : BEGIN
          message,'pixel not on edge of map',/info
        END
      ENDCASE
    END
  ENDCASE
ENDIF ELSE BEGIN  ;anticlockwise
  CASE i OF
    naxis1-1: BEGIN
      IF j NE naxis2-1 THEN BEGIN
        inext=i & jnext=j+1
      ENDIF ELSE BEGIN
        inext=i-1 & jnext=j
      ENDELSE
    END
    0: BEGIN
      IF j NE 0 THEN BEGIN
        inext=i & jnext=j-1
      ENDIF ELSE BEGIN
        inext=i+1 & jnext=j
      ENDELSE  
    END
    ELSE : BEGIN
      CASE j OF
        naxis2-1: BEGIN
          IF i NE 0 THEN BEGIN
            inext=i-1 & jnext=j
          ENDIF ELSE BEGIN
            inext=i & jnext=j-1
          ENDELSE
        END
        0: BEGIN
          IF i NE (Naxis1-1) THEN BEGIN
            inext=i+1 & jnext=j
          ENDIF ELSE BEGIN
            inext=i & jnext=j+1
          ENDELSE        
        END
        ELSE : BEGIN
          message,'pixel not on edge of map',/info
        END
      ENDCASE
    END
  ENDCASE
ENDELSE

RETURN,[inext,jnext]

END