FUNCTION scale_header_sky_area,hh,fact

;scales a fits header by some factor
;the pixel size is scaled by fact
;so that the sky area covered is also multiplied by fact

h=hh

;scales the header by some factor
cdelt1=sxpar(h,'CDELT1') & cdelt2=sxpar(h,'CDELT2')
;crpix1=sxpar(h,'CRPIX1') & crpix2=sxpar(h,'CRPIX2')

new_cdelt1=cdelt1*fact & new_cdelt2=cdelt2*fact

sxaddpar,h,'CDELT1',new_cdelt1 & sxaddpar,h,'CDELT2',new_cdelt2

RETURN,h

END
