FUNCTION gaussian_integ_fun,values,coo1,coo2,c1_center,c2_center,connectivity_ptr,ipix, $
                            fwhm=fwhm,n_neighboor=n_neighboor

;fwhm in degrees
;conn=*connectivity_ptr(ipix)
IF values(ipix) EQ !indef then RETURN,!indef

conn=expand_connectivity(connectivity_ptr,ipix,n_neighboor)
;c=(*connectivity_ptr(ipix))
;plot,coo1(conn),coo2(conn),/ysty,psym=4
;oplot,coo1(c),coo2(c),color=100,psym=4
;wait,1

gcirc,0,coo1(conn)/!radeg,coo2(conn)/!radeg,c1_center/!radeg,c2_center/!radeg,dist
dist=dist*!radeg
dmax=max(dist)
ll=2.7725887            ;=-4*alog(0.5)
a2=fwhm/ll

;normalisation for an infinite size neighborhood region
;norm=2.*!pi*a2           ;because int(0,!inf,2*!pi*r*exp(-r^2/2/a^2)*dr)=2.*!pi*a^2
;norm=2.*!pi*a2(1.-exp(-dmax^2/2./a2)) ;because int(0,dmax,2*!pi*r*exp(-r^2/2/a^2)*dr)=2.*!pi*a^2*(1-exp(-dmax^2/2/a^2))
norm=1.  ;nothing here
gauss=exp(-dist^2/2./a2)/norm
vv=values(conn)
ind=where(vv NE !indef,count)
IF count NE 0 THEN BEGIN
  B=total(vv(ind)*gauss(ind))/total(gauss(ind))
ENDIF ELSE BEGIN
  B=!indef
ENDELSE

RETURN,B

END