PRO fix_ps4ill10,ps_file,file_out

;Modifies images in a postcript file to pass it from 4bits/pixels
;into 8bit/pixels. Used to modify poscript files generated using
;4 bits/pixels, so they can be interpreted by the MPS parser
;of Adobe illustrator 10.
;uses expand8bit.pro with method=2
;Reading of big images sometimes causes all_str to be corrupted,
;which causes the program to stap with 'Something went wrong ...'
;I do not understand what causes that, at the moment. There must
;be something wrong with strmid on very long character chains

str=''
str2=''
get_lun,unit
get_lun,unit2
openr,unit,ps_file
openw,unit2,file_out
chunck_size=80L

WHILE str NE '%%EOF' DO BEGIN
  readf,unit,str
  pos=strposmulti(str,'/picstr',count)
  IF count NE 0 THEN BEGIN
    message,'Found an image',/info
    strs=str_sep(str,' ')
    Nel=(size(strs))(1)
    IF Nel NE 20 THEN BEGIN
      readf,unit,str2
      str=strcompress(str+' '+str2)
    ENDIF
    strs=str_sep(str,' ')
    print,'original im:'+str
    indpicstr=where(strs EQ '/picstr')
    picstr=strs(indpicstr(0)+1)
    indscale=where(strs EQ 'scale')
    scalex=long(strs(indscale(0)+1))
    scaley=long(strs(indscale(0)+2))
    bits=long(strs(indscale(0)+3))
    strs(indscale(0)+3)=strtrim(8,2)
    strs(indpicstr+1)=strtrim(scalex,2)
    str2=''
    FOR i=0L,n_elements(strs)-1 DO BEGIN
      str2=str2+strs(i)+' '
    ENDFOR
    IF bits NE 4 THEN BEGIN
      str=str2
      goto,next
    ENDIF
    printf,unit2,str2
    print,'modified to:'+str2
;    stop
    WHILE str NE '{J} image' DO BEGIN
      READF,unit,str
      printf,unit2,str
    ENDWHILE
    ;Start reading image data and transform to 8 bit
    all_str=''
    REPEAT BEGIN
      readf,unit,str
;      print,str
      IF strmid(str,0,8) NE 'grestore' THEN BEGIN
        all_str=all_str+str
      ENDIF
    ENDREP UNTIL strmid(str,0,8) EQ 'grestore'
    ;transform image to 8 bit
    Nel=1.*scalex*scaley
    Nstr=long(Nel/chunck_size)
;    stop
;   If format requieres, read blocks of size 8
;   (e.g. for color tables generated by imcont20)
    IF strlen(all_str) NE Nel THEN BEGIN
      all_str2=''
      istart=0L
      FOR i=0L,scaley-1 DO BEGIN
;        stop
        all_str2=all_str2+strmid(all_str,istart,7)
        istart=istart+8
      ENDFOR
      all_str=all_str2
    ENDIF
;   transform the image to 8 bits
    istart=0L
    check_s=0L
    all_str3=all_str
    FOR i=0L,Nstr-1 DO BEGIN
;      print,strlen(all_str3)
      sstr=strmid(all_str3,istart,chunck_size)
;      print,istart+chunck_size
;      all_str3=strmid(all_str3,istart+chunck_size)
      IF strlen(sstr) NE chunck_size THEN BEGIN
        message,'Something went wrong ...',/info
        stop
      ENDIF
      all_str2=expand8bit(sstr,method=2)
      istart=istart+chunck_size
      printf,unit2,all_str2
      check_s=check_s+strlen(sstr)
;      print,strlen(sstr),check_s,chunck_size*(i+1)
    ENDFOR
    print,check_s,Nstr*chunck_size
    IF chunck_size*Nstr NE Nel THEN BEGIN
      sstr=strmid(all_str,istart,Nel-chunck_size*Nstr)
      all_str2=expand8bit(sstr,method=2)
      printf,unit2,all_str2
      check_s=check_s+strlen(sstr)
    ENDIF
    IF check_s NE Nel THEN BEGIN
      message,'Something went wrong ...',/info
      message,'check_s='+strtrim(check_s,2)+' Nel='+strtrim(Nel,2),/info
      stop
    ENDIF
next:
    printf,unit2,str
  ENDIF ELSE BEGIN
    printf,unit2,str
  ENDELSE
ENDWHILE

close,unit
close,unit2

END