pro imcont21,bidon,data=data,header=header,title=title,imrange=imrange, $
             overx=overx,overy=overy,grid=grid,square=square, $
             levels=levels,coo1=coo1,coo2=coo2,bw=bw

;+
; NAME:
;       imcont21
; PURPOSE:
;       display fits images
; CATEGORY:
;       
; CALLING SEQUENCE:
;	imcont8
; INPUTS:
;       
; OPTIONAL INPUT PARAMETERS:
; OUTPUTS:
;       None
; OPTIONAL OUTPUT PARAMETERS:
; COMMON BLOCKS:
; SIDE EFFECTS:
; RESTRICTIONS:
; PROCEDURE:
; PRO and FUNCTION USED:
;	image_cont20
; MODIFICATION HISTORY:
;      20-Avr-1996, Written by Jean-Philippe Bernard
;      4-Nov-1997, Modified JPB to remove commons (use state)
;-
@comxrdpix.com
@imcont8_common.com

;common mess_rdspm_im,text_message_im
;common graph_im,window_im
;common wid_im,Wcolormin,Wcolormax,Wlevmin,Wlevstep
;common imhead,d,h,tit,imr,ovx,ovy,csiz,gri,squa,lev,co1,co2,off_bar_pos
common imhead,ovx,ovy,lev

common scalecom,scale_im,maxim,minim,min_lev, $
       step_lev,lev_vals,imra,previous_path
;common zoom_im,zoom_scale,zoom_cent,Wzoomcent1,Wzoomcent2
common select,range_select,levels_select
common overlay,ovxx,ovyy,symbol_size,symbol_color,symbol_value
;common double,double
;common doprint,doprint
common bw,bw_c
common dcontour,dcont,hcont,dcont_over

w_state={base:0l,rd_col:0l,rd_cont:0l,write:0l,disp:0l,ctload:0l,loadcat:0l, $
         quit:0l,print:0l,info:0l, $
         pix_value:0l, $
         draw:0l, $
         filename:0l, $
         scale_slider:0l, $
         levels_set:0l,range_set:0l,grid_set:0l,bar_set:0l,bw_set:0l, $
         colormin:0l,colormax:0l, $
         levmin:0l,levstep:0l, $
         zoom:0l,zoom_slider:0l,zoom_cent1:0l,zoom_cent2:0l, $
         tex_mess:0l}

v_state={outfile:'',zoom_cent:fltarr(2),zoom_scale:2.,doprint:0, $
         previous_path:' ',filter:' ', $
         imrange:fltarr(2),square:0,title:' ',grid:0,calcoo:0, $
         range_select:0,level_select:0, $
         off_bar_pos:fltarr(4), $
         scale_im:0., $
         last_sz:lonarr(5),last_sx:0.,last_sy:0.,last_pos:fltarr(2)}

Nx=10 & Ny=10 & Nh=10
im_state={image:fltarr(Nx,Ny),header:strarr(Nh), $
         imcont:fltarr(Nx,Ny),hcont:strarr(Nh), $
         imcont_over:fltarr(Nx,Ny), $
         coo1:fltarr(Nx,Ny),coo2:fltarr(Nx,Ny), $
         last_image:fltarr(Nx,Ny),last_header:strarr(Nh)}

v_state.square=1

symbol_color=199
;double=0
v_state.doprint=0
;removed to be able to have several windows   	
;   	if xregistered('imcont8') then begin
;      	   xmanager
;      	   return
;   	endif

zmcent1=''
zmcent2=''
;***** Definition du widget de base                            
;==================== Definition  of the base widget     
;bar=0 
bar=1
IF bar NE 0 THEN BEGIN                     
  base = widget_base(title = 'imcont21',/column,mbar=bar) 
ENDIF ELSE BEGIN
  base = widget_base(title = 'imcont21',/column)
ENDELSE
print,'Bar widget =',bar
print,'Base Widget =',base
w_state.base=base
IF bar NE 0 THEN child1=bar ELSE child1 = widget_label(base,value='')
;==================== First button line
IF bar EQ 0 THEN BEGIN
  fbl = widget_base(base,/row)
ENDIF ELSE BEGIN
  fbl=bar
ENDELSE

junk = {cw_pdmenu_s,flags:0, name :''}
desc = [{cw_pdmenu_s,1,'File'}, $
        {cw_pdmenu_s,1,'Read ...'}, $
        {cw_pdmenu_s,0,'Color Image'}, $
        {cw_pdmenu_s,2,'Contour Image'}, $
        {cw_pdmenu_s,0,'Write ...'}, $
        {cw_pdmenu_s,1,'Print'}, $
        {cw_pdmenu_s,0,'PS'}, $
        {cw_pdmenu_s,0,'PCL'}, $
        {cw_pdmenu_s,0,'Color PS File'}, $
        {cw_pdmenu_s,0,'B&W PS File'}, $
        {cw_pdmenu_s,2,'PCL File'}, $
        {cw_pdmenu_s,0,'Quit'}]
toto = cw_pdmenu(fbl,desc,/return_name,uvalue='FILE',mbar=bar)
desc = [{cw_pdmenu_s,1,'Set'}, $
        {cw_pdmenu_s,0,'Color Table ...'}]
toto = cw_pdmenu(fbl,desc,/return_name,uvalue='SET',mbar=bar)
desc = [{cw_pdmenu_s,1,'Info'}, $
        {cw_pdmenu_s,0,'Header Info ...'}]
toto = cw_pdmenu(fbl,desc,/return_name,uvalue='INFO',mbar=bar)
desc = [{cw_pdmenu_s,1,'Display'}, $
        {cw_pdmenu_s,0,'Display Map'}]
toto = cw_pdmenu(fbl,desc,/return_name,uvalue='DISP',mbar=bar)
desc = [{cw_pdmenu_s,1,'Load'}, $
        {cw_pdmenu_s,0,'Star Catalog ...'}]
toto = cw_pdmenu(fbl,desc,/return_name,uvalue='LOADCAT',mbar=bar)

;w_state.disp=WIDGET_BUTTON(fbl,VALUE='Disp',UVALUE='DISP')
;w_state.ctload=WIDGET_BUTTON(fbl,VALUE='loadct',UVALUE='CTLOAD')
;w_state.loadcat=WIDGET_BUTTON(fbl,VALUE='loadcat',UVALUE='LOADCAT')
;w_state.quit=WIDGET_BUTTON(fbl,VALUE='Quit',UVALUE='QUIT')

;junk = {cw_pdmenu_s,flags:0, name :''}
;desc = [{cw_pdmenu_s,1,'Print'}, $
;        {cw_pdmenu_s,0,'ps'}, $
;        {cw_pdmenu_s,0,'pcl'}, $
;        {cw_pdmenu_s,0,'color ps file'}, $
;        {cw_pdmenu_s,0,'B&W   ps file'}, $
;        {cw_pdmenu_s,0,'     pcl file'}]
;w_state.print = cw_pdmenu(fbl,desc,/return_name,uvalue='PRINT')

;	xpdmenu,['"INFO"		INFO'],first_button_line
;w_state.info=WIDGET_BUTTON(fbl,VALUE='INFO',UVALUE='INFO')

; Affichage de la valeur du pixel
pv  = widget_base(base,/row)
l_pix_value = widget_label(pv,value='')
xs=55
IF !version.os EQ 'MacOS' THEN xs=100
w_state.pix_value = widget_text(pv,xsize=xs)
;Display window
ppal = widget_base(base,/row)
dimx = 600
dimy= 512  
w_state.draw = widget_draw(ppal,colors = 256,$                               
                   /motion_events,uvalue = 'RDPIX' ,$
                   /frame,xsize=dimx*1, $
                   ysize=dimy*1,/button_events)
;PS filename
w_filename= widget_base(base,/row)
toto = widget_label(w_filename,value = "Filename:")
v_state.outfile='IDL.PS'
w_state.filename =  widget_text(w_filename,/editable,uvalue = 'FNAME', $
                     xsize = 20, $
                     value=v_state.outfile)


w_control = widget_base(base,/row,/frame)
;Scale Slider
w_control1 = widget_base(w_control,/column,/frame)
v_state.scale_im=3.
w_state.scale_slider = WIDGET_SLIDER(w_control1, $
                               MINIMUM = 1, MAXIMUM = 10, $
                               VALUE  = v_state.scale_im, $
                               UVALUE = "SCALE")
w_scale_title  = WIDGET_LABEL(w_control1,value='Scale')
;Controler
w_control2 = widget_base(w_control,/column,/frame,/nonexclusive) 
w_state.levels_set = WIDGET_BUTTON(w_control2, $
                         VALUE = 'Levels', $
                         UVALUE = "LEVELS")
w_state.range_set = WIDGET_BUTTON(w_control2, $
                        VALUE = 'Range', $
                        UVALUE = "RANGE")
w_state.grid_set = WIDGET_BUTTON(w_control2, $
                       VALUE = 'Grid', $
                       UVALUE = "GRID")
w_state.bar_set = WIDGET_BUTTON(w_control2, $
                      VALUE = 'Bar', $
                      UVALUE = "BAR")
w_state.bw_set = WIDGET_BUTTON(w_control2, $
                      VALUE = 'B&W', $
                      UVALUE = "BW")


;Color minmax
w_control3 = widget_base(w_control,/column,/frame)
w_control4 = widget_base(w_control,/column,/frame)
w_control5 = widget_base(w_control,/column,/frame)
;v_state.zoom_scale=2.
IF keyword_set(data) AND keyword_set(header) THEN BEGIN
    d=data
    h=header
    ind=where(d NE !indef,count)
    show_imrange=minmax(d(ind))
    show_maxim=string(show_imrange(1),format='(E9.2)')
    show_minim=string(show_imrange(0),format='(E9.2)')
;Initialize zoom center to image center
    cdelt1=sxpar(h,'CDELT1') & cdelt2=sxpar(h,'CDELT2')
    naxis1=sxpar(h,'NAXIS1') & naxis2=sxpar(h,'NAXIS2')
    siz=ABS([Naxis1*cdelt1,Naxis2*cdelt2])/v_state.zoom_scale
    crval1=sxpar(h,'CRVAL1') & crval2=sxpar(h,'CRVAL2')
    v_state.zoom_cent=[crval1,crval2]
    zmcent1=string(v_state.zoom_cent(0),format='(E9.2)')
    zmcent2=string(v_state.zoom_cent(1),format='(E9.2)')
ENDIF ELSE BEGIN
    show_maxim=string(0.,format='(E9.2)')
    show_minim=string(0.,format='(E9.2)')
ENDELSE
w_colormin = widget_base(w_control3,/row)
w = widget_label(w_colormin,value = "Min:")
w_state.colormin =  widget_text(w_colormin,/editable, $
                         uvalue = 'COLORMIN',xsize = 9, $
                         value=show_minim)
widget_control,w_state.colormin,sensitive=0       
w_colormax = widget_base(w_control3,/row)
w = widget_label(w_colormax,value = "Max:")
w_state.colormax =  widget_text(w_colormax,/editable, $
                         uvalue = 'COLORMAX',xsize = 9, $
                         value=show_maxim)
widget_control,w_state.colormax,sensitive=0

;level minmax
w_levmin = widget_base(w_control4,/row)
w = widget_label(w_levmin,value = "Min:")
w_state.levmin =  widget_text(w_levmin,/editable, $
                              uvalue = 'LEVMIN',xsize = 9)
widget_control,w_state.levmin,sensitive=0
w_levstep = widget_base(w_control4,/row)
w = widget_label(w_levstep,value = "Step:")
w_state.levstep =  widget_text(w_levstep,/editable, $
                               uvalue = 'LEVSTEP',xsize = 9)
widget_control,w_state.levstep,sensitive=0

;Zoom
w_state.zoom = WIDGET_BUTTON(w_control5,VALUE = 'Zoom',UVALUE = "ZOOM")
v_state.zoom_scale=2.
w_state.zoom_slider = WIDGET_SLIDER(w_control5,MINIMUM = 1, MAXIMUM = 10, $
                               VALUE=v_state.zoom_scale, $
                               UVALUE = "ZOOMSCALE")
w_state.zoom_cent1 =  widget_text(w_control5,/editable, $
                          uvalue = 'ZOOMCENT1',xsize = 9, $
                          value=zmcent1)
w_state.zoom_cent2 =  widget_text(w_control5,/editable, $
                          uvalue = 'ZOOMCENT2',xsize = 9, $
                          value=zmcent2) 	
widget_control,w_state.levstep,/sensitive
	
;widget text for errors
label_message = widget_label(w_state.base,value = "Messages :")
w_state.tex_mess = widget_text(w_state.base,xsize=45)


;;widget_control,draw,get_value = window_im    

IF keyword_set(title) THEN tit=title ELSE tit=' '
IF keyword_set(overx) THEN ovx=overx
IF keyword_set(overy) THEN ovy=overy
IF keyword_set(imrange) THEN imr=imrange
IF keyword_set(grid) THEN gri=grid
IF keyword_set(square) THEN squa=square
IF keyword_set(levels) THEN lev=levels
if keyword_set(bw) then bw_c=1 else bw_c=0
if keyword_set(bw) then widget_control,w_bw,/SET_BUTTON

widget_control,base,/realize

;Initialize with the image, if necessary
IF keyword_set(data) AND keyword_set(header) THEN BEGIN
    d=data
    h=header
    ind=where(d NE !indef,count)
    v_state.imrange=minmax(d(ind))
    maxim=v_state.imrange(1) & minim=v_state.imrange(0)
    imr=v_state.imrange
    
    old_position=!p.position
    !p.position=[0.6/v_state.scale_im,0.5/v_state.scale_im, $
                 1.-0.3/v_state.scale_im,1.-0.4/v_state.scale_im]
    init_xaxis & init_yaxis
;          stop
    dcont_over=d

    ind=where(v_state.off_bar_pos NE 0,count)
    IF count NE 0 THEN obp=state.var.off_bar_pos ELSE obp=0
    image_cont20,d,h,imrange=v_state.imrange, $
                 title=v_state.title,/silent, $
                 grid=v_state.grid,square=v_state.square, $
                 levels=levels, $
                 coo1=coo1,coo2=coo2,bw=bw_c,off_bar_pos=obp

    v_state.last_sz=last_sz & v_state.last_pos=last_pos
    v_state.last_sx=last_sx & v_state.last_sy=last_sy
;    set_state,state,last_image=last_image,last_header=last_header
;    	  stop
    imra=imr
    !p.position=old_position
ENDIF ELSE BEGIN
    imr=0
    imra=0
ENDELSE

v_state.calcoo=0
IF keyword_set(coo1) AND keyword_set(coo2) THEN v_state.calcoo=1

v_state.range_select=0
;	levels_select=0
;previous_path='$HOME'           ; M00008

v_state.previous_path='/users1/bernard/'
v_state.filter='*.fits'

lev=0 & v_state.level_select=0
;	imr=0 & range_select=0
v_state.range_select=0
gri=0
squa=1
;	bar=0
v_state.off_bar_pos=0

;widget_control,base,/realize
state={widgets:w_state,var:v_state,ims:im_state}
set_state,state,last_image=last_image,last_header=last_header
IF keyword_set(coo1) THEN BEGIN
    set_state,satet,coo1=coo1
;    coo1=1.
ENDIF
IF keyword_set(coo2) THEN BEGIN
    set_state,satet,coo2=coo2
;    coo2=1.
ENDIF
IF keyword_set(data) THEN set_state,state,image=data
IF keyword_set(header) THEN set_state,state,header=header

;put state in Child1
widget_control,child1,set_uvalue=state

xmanager,'imcont21',w_state.base,/no_block,event_handler='imcont21_event'

;xmanager,"imcont20",base

sortie:

end                              
  

