pro imcont21_event,ev

@comxrdpix.com
@imcont8_common.com

;common mess_rdspm_im
;common imhead,d,h,title,imrange,overx,overy,csize,grid,square,levels, $
;              coo1,coo2,off_bar_pos
common imhead,overx,overy,levels
common scalecom,scale_im,maxim,minim,min_lev,step_lev,lev_vals, $
                imra,previous_path
;common zoom_im,zoom_scale,zoom_cent
;common select,range_select,levels_select
;common printfile,outfile
common overlay,ovxx,ovyy,symbol_size,symbol_color,symbol_value
;common double,double
;common doprint,doprint

common bw,bw_c
;common dcontour,dcont,hcont,dcont_over

child1=widget_info(ev.handler,/child)
;=========== Get the state structure
widget_control,child1,get_uvalue=state,/no_copy


;=========== Get user value of the event
widget_control,ev.id,get_uvalue = eventval
IF  defined(eventval) EQ 0 THEN BEGIN
  eventval='MENU BAR'
ENDIF

;=========== get some widget numbers
mess=state.widgets.tex_mess
Wcolormin=state.widgets.colormin
Wcolormax=state.widgets.colormax
Wlevmin=state.widgets.levmin
Wlevstep=state.widgets.levstep
Wzoomcent1=state.widgets.zoom_cent1
Wzoomcent2=state.widgets.zoom_cent2
Wpix_value=state.widgets.pix_value
;get some variables
;outfile=state.var.outfile
;zoom_im=state.var.zoom_im
zoom_scale=state.var.zoom_scale
;zoom_cent=state.var.zoom_cent

;widget_control,ev.id,get_uvalue = eventval ; Obtient le button index du menu

CASE eventval  OF
    'MENU BAR' : BEGIN
            to_be_printed=0 & print_file=0
            pcl=0 & postcript=0 & print=0 & ps_color=0
            CASE ev.value OF
                'Color Image' : BEGIN
                    file=pickfile(get_path=previous_path, $
                        path=state.var.previous_path,/read, $
                        filter=state.var.filter)
        
                    state.var.previous_path=previous_path
                    pos=strpos(previous_path,'/tmp_mnt')
                    IF pos NE -1 THEN state.var.previous_path= $
                                               strmid(previous_path, $
                                               pos+8,strlen(previous_path)-8)
                    IF file NE previous_path THEN BEGIN
                       d=readfits(file,h)
                      set_state,state,image=d,header=h
                      ind=where(state.ims.image NE !indef,count)
                      maxim=max(state.ims.image(ind)) & minim=min(state.ims.image(ind))
                     si=size(imra)
                    IF si(0) NE 0 THEN BEGIN
                         state.var.imrange=[max([minim,imra(0)]),min([maxim,imra(1)])]
                    ENDIF ELSE BEGIN
                        state.var.imrange=[minim,maxim]
                        imra=state.var.imrange
                    ENDELSE
                        text = 'Image Range = ['+string(state.var.imrange(0))+ $
                             ' , '+string(state.var.imrange(1))
                       widget_control,state.widgets.tex_mess,set_value = text
                   ;Compute coordinates if necessary
                   IF state.var.grid EQ 1 THEN BEGIN
                       create_coo2,state.ims.header,coo1,coo2,/silent
                       set_state,state,coo1=coo1,coo2=coo2
                       coo1=1 & coo2=1
                   ENDIF ELSE BEGIN
                      state.var.calcoo=0
                   ENDELSE
                   ;Set the min max range
                   ind=where(state.ims.image NE !indef,count)
                  show_imrange=minmax(state.ims.image(ind))
                  state.var.imrange=show_imrange
                  show_maxim=string(show_imrange(1),format='(E9.2)')
                  show_minim=string(show_imrange(0),format='(E9.2)')
                  widget_control,Wcolormin,set_value = show_minim
                  widget_control,Wcolormax,set_value = show_maxim

                 ;Set the zoom center to center of new image
                 units=sxpar(h,'BUNIT')
                 cdelt1=sxpar(h,'CDELT1') & cdelt2=sxpar(h,'CDELT2')
                 naxis1=sxpar(h,'NAXIS1') & naxis2=sxpar(h,'NAXIS2')
                 siz=ABS([Naxis1*cdelt1,Naxis2*cdelt2])/zoom_scale
                 crval1=sxpar(h,'CRVAL1') & crval2=sxpar(h,'CRVAL2')
                 state.var.zoom_cent=[crval1,crval2]
                 zmcent1=string(state.var.zoom_cent(0),format='(E9.2)')
                 zmcent2=string(state.var.zoom_cent(1),format='(E9.2)')
                 widget_control,Wzoomcent1,set_value = zmcent1
                 widget_control,Wzoomcent2,set_value = zmcent2
                 set_state,state,hcont=state.ims.header, $
                            imcont=state.ims.image, $
                            im_over=state.ims.imcont
             ENDIF
         END

        'Contour Image' : BEGIN
                file=pickfile(get_path=previous_path, $
                      path=state.var.previous_path,/read, $
                      filter=state.var.filter)
                state.var.previous_path=previous_path
                pos=strpos(previous_path,'/tmp_mnt')
                IF pos NE -1 THEN previous_path=strmid(previous_path, $
                                               pos+8,strlen(previous_path)-8)
                IF file NE previous_path THEN BEGIN
                    d=readfits(file,hcont)
                    set_state,state,imcont=d,hcont=hcont
                ENDIF
                ; reproject the contour data on the color image	      	      
                d=project2(state.ims.hcont,state.ims.imcont, $
                                       state.ims.header)
                set_state,state,im_over=d
          END
    
         'Write' : BEGIN
                file=pickfile(get_path=previous_path, $
                      path=state.var.previous_path,/write, $
                      filter=state.var.filter)
               IF file NE previous_path THEN BEGIN
                    ok = strpos(file,previous_path)
                    IF ok eq -1 then BEGIN
                        file=previous_path+file
                    ENDIF
                    writefits,file,state.ims.image,state.ims.header
                    text = 'File '+file+' written'
                    widget_control,mess,set_value = text
               ENDIF ELSE BEGIN
                   text = 'No file written'
                   widget_control,mess,set_value = text
               ENDELSE
         END
         'B&W PS File' : BEGIN
               bw_c = ev.select
               to_be_printed=1
               print_file=1
         END   
         'PCL File': BEGIN
               pcl=1 & to_be_printed=1
               ps_color=1 & print_file=1
         END
         'PCL':BEGIN
               pcl=1 & to_be_printed=1
               print=1
               ps_color=1
         END
         'PS':BEGIN
               print=1 & to_be_printed=1
         END
         'Color PS File':BEGIN
               ps_color=1 & to_be_printed=1
               print_file=1
         END

         'Quit' : BEGIN
                    widget_control,ev.top,/destroy
                    RETURN
          END
          'Header Info ...' : BEGIN
                    xhprint,h
          END
    
          'Color Table ...' : BEGIN
                    xloadct
          END
          'LOADCAT'  : BEGIN
              xloadcat                ; load catalog
              overx=ovxx & overy=ovyy
              csize=symbol_size
          END
          'Display Map' : BEGIN
             text='Displaying image ...'
             widget_control,mess,set_value = text
             old_position=!p.position
             !p.position=[0.6/state.var.scale_im,0.5/state.var.scale_im, $
                     1.-0.3/state.var.scale_im,1.-0.4/state.var.scale_im]
             init_xaxis & init_yaxis
             ind=where(state.var.off_bar_pos NE 0,count)
             IF count NE 0 THEN obp=state.var.off_bar_pos ELSE obp=0
             ;stop
             image_cont20,state.ims.image,state.ims.header, $
                square=state.var.square, $
                imrange=state.var.imrange,/silent,title=state.var.title, $
                grid=state.var.grid,levels=levels, $
                coo1=state.ims.coo1,coo2=state.ims.coo2, $
                off_bar_pos=obp

             state.var.last_sz=last_sz & state.var.last_pos=last_pos
             state.var.last_sx=last_sx & state.var.last_sy=last_sy
             set_state,state,last_image=last_image,last_header=last_header

             !p.position=old_position
             text='Done.'
             widget_control,mess,set_value = text
          END
          ELSE: BEGIN
                    print,ev.value,' is an Unused Menu Event'
          END
        ENDCASE
        ;====== Print the image, if necessary
         IF to_be_printed EQ 1 THEN BEGIN
               old_position=!p.position
              !p.position=[0.6/state.var.scale_im,0.5/state.var.scale_im, $
                                  1.-0.3/state.var.scale_im,1.-0.4/state.var.scale_im]
              old_device = !d.name
              ;pcl=0 & postcript=0 & print=0 & ps_color=0
              selection=strtrim(strcompress(ev.value),2)
              IF print_file EQ 1 THEN BEGIN
                   file=pickfile(get_path=previous_path, $
                      path=state.var.previous_path,/write, $
                      filter=state.var.filter)
                   IF file NE previous_path THEN BEGIN
                        ok = strpos(file,previous_path)
                        IF ok eq -1 then BEGIN
                            file=previous_path+file
                       ENDIF
                       postcript=file
                  ENDIF ELSE BEGIN
                       text = 'No File Selected'
                       widget_control,mess,set_value = text
                  ENDELSE
              ENDIF
              text = 'Printing the image ...'
              widget_control,mess,set_value = text
                        
               ind=where(state.var.off_bar_pos NE 0,count)
               IF count NE 0 THEN obp=state.var.off_bar_pos ELSE obp=0
               image_cont20,state.ims.image,state.ims.header, $
                           imrange=state.var.imrange,/invert,print=print, $
                           /silent, $
                          title=state.var.title, $
                          grid=state.var.grid, $
                          square=state.var.square,levels=levels, $
                          coo1=state.ims.coo1,coo2=state.ims.coo2, $
                         pcl=pcl,off_bar_pos=state.var.obp, $
                         postcript=postcript,ps_color=ps_color, $
                         bw=bw_c
                 state.var.last_sx=last_sx & state.var.last_pos=last_pos
                 state.var.last_sx=last_sx & state.var.last_sy=last_sy
                 set_state,state,last_image=last_image,last_header=last_header

                 IF state.var.doprint EQ 0 THEN BEGIN
                           text = 'Printing Done. DO IT ONCE AGAIN !'
                           state.var.doprint=1
                  ENDIF ELSE BEGIN
                          text = 'Printing Done'
                  ENDELSE   
                  widget_control,mess,set_value = text

              ENDIF

    END

    
    "ZOOM"  : BEGIN
        print,'zoom scale=',zoom_scale
        h=state.ims.header
        cdelt1=sxpar(h,'CDELT1') & cdelt2=sxpar(h,'CDELT2')
        naxis1=sxpar(h,'NAXIS1') & naxis2=sxpar(h,'NAXIS2')
        siz=ABS([Naxis1*cdelt1,Naxis2*cdelt2])/zoom_scale
        text = 'Zooming on = ['+string(state.var.zoom_cent(0), $
                               format='(E9.2)')+','
        text=text+string(state.var.zoom_cent(1),format='(E9.2)')+' ] ....'
        widget_control,mess,set_value = text
        res=zmy(state.ims.image,state.ims.header, $
                siz,hout,centcoord=state.var.zoom_cent,/silent)
        set_state,state,image=res,header=hout
        IF state.var.level_select THEN BEGIN
            toto=project2(state.ims.hcont,state.ims.imcont, $
                                state.ims.header)
            set_state,state,im_over=toto
        endif   
        ind=where(state.ims.image NE !indef,count)
        minim=min(state.ims.image(ind)) & maxim=max(state.ims.image(ind))
        show_imrange=[minim,maxim]
        show_maxim=string(show_imrange(1),format='(E9.2)')
        show_minim=string(show_imrange(0),format='(E9.2)')
        widget_control,Wcolormin,set_value = show_minim
        widget_control,Wcolormax,set_value = show_maxim
        state.var.imrange=[max([minim,state.var.imrange(0)]), $
                           min([maxim,state.var.imrange(1)])]
        IF state.var.calcoo EQ 1 THEN BEGIN
            text = 'Creating coordinates ....'
            widget_control,mess,set_value = text
            create_coo2,state.ims.header,coo1,coo2,/silent
            set_state,state,coo1=coo1,coo2=coo2
            coo1=1 & coo2=1
        ENDIF
        text = 'Done.'
        widget_control,mess,set_value = text
    END
    "ZOOMSCALE" : BEGIN
        zoom_scale=ev.value
    END
    "ZOOMCENT1" : BEGIN
;        IF not defined(zoom_cent) THEN zoom_cent=fltarr(2)
        widget_control,ev.id,get_value = valeur
        show_valeur = string(valeur,format='(E9.2)')
        widget_control,ev.id,set_value = show_valeur                      
;        zoom_cent(0) = float(valeur(0))
        state.var.zoom_cent(0)= float(valeur(0))
        text = 'Zoom center = ['+string(state.var.zoom_cent(0), $
                              format='(E9.2)')+','
        text=text+string(state.var.zoom_cent(1),format='(E9.2)')+' ]'
        widget_control,mess,set_value = text
    END
    "ZOOMCENT2" : BEGIN
;        IF not defined(zoom_cent) THEN zoom_cent=fltarr(2)
        widget_control,ev.id,get_value = valeur
        show_valeur = string(valeur,format='(E9.2)')
        widget_control,ev.id,set_value = show_valeur                      
        state.var.zoom_cent(1) = float(valeur(0))
        text = 'Zoom center = ['+string(state.var.zoom_cent(0), $
                                format='(E9.2)')+','
        text=text+string(state.var.zoom_cent(1),format='(E9.2)')+' ]'
        widget_control,mess,set_value = text                   
    END
    
    "COLORMIN" : BEGIN                                                     
        widget_control,ev.id,get_value = valeur
        show_valeur = string(valeur,format='(E9.2)')
        widget_control,ev.id,set_value = show_valeur         
        imra(0) = float(valeur(0))                               
        IF state.var.range_select THEN BEGIN
;                imrange=[max([minim,imra(0)]),min([maxim,imra(1)])]
            state.var.imrange=imra
            text = 'imrange set to ['+string(state.var.imrange(0))+ $
                                    ','+string(state.var.imrange(1))+']'
            widget_control,mess,set_value = text
        ENDIF
    END
    "COLORMAX" : BEGIN                                                     
        widget_control,ev.id,get_value = valeur
        show_valeur = string(valeur,format='(E9.2)')
        widget_control,ev.id,set_value = show_valeur         
        imra(1) = float(valeur(0))                               
        IF state.var.range_select THEN BEGIN
            state.var.imrange=imra
;                imrange=[max([minim,imra(0)]),min([maxim,imra(1)])]
            text = 'imrange set to ['+string(state.var.imrange(0))+ $
                   ','+string(state.var.imrange(1))+']'
            widget_control,mess,set_value = text
        ENDIF                                                     
    END
    
    "RANGE" : BEGIN
        IF ev.select THEN BEGIN
            state.var.range_select=1
            state.var.imrange=imra
;               imrange=[max([minim,imra(0)]),min([maxim,imra(1)])]
            text = 'imrange set to ['+string(state.var.imrange(0))+ $
                   ','+string(state.var.imrange(1))+']'
            widget_control,Wcolormin,/sensitive
            widget_control,Wcolormax,/sensitive
        ENDIF ELSE BEGIN
            state.var.range_select=0
            state.var.imrange=[minim,maxim]
            text = 'imrange set to ['+string(state.var.imrange(0))+ $
                   ','+string(state.var.imrange(1))+']'
            widget_control,Wcolormin,sensitive=0
            widget_control,Wcolormax,sensitive=0
        ENDELSE
        widget_control,mess,set_value = text
    END
    
    
    "LEVMIN" : BEGIN                                                     
        widget_control,ev.id,get_value = valeur
        show_valeur = string(valeur,format='(E9.2)')
        widget_control,ev.id,set_value = show_valeur                           
        min_lev = float(valeur(0))
        lev_vals=[min_lev] 
        p=where(state.ims.imcont_over ne !indef,count)
        if count ne 0 then maxim_cont = max(state.ims.imcont_over(p))
        
        IF defined(step_lev) THEN BEGIN
            n_lev=FIX((maxim_cont-min_lev)/step_lev)
            lev_vals=findgen(n_lev)*step_lev+min_lev
            IF n_lev GT 30 THEN lev_vals=lev_vals(0:29)
        ENDIF
        IF state.var.level_select THEN levels=lev_vals    
    END
    
    "LEVSTEP" : BEGIN                                                     
        widget_control,ev.id,get_value = valeur
        show_valeur = string(valeur,format='(E9.2)')
        widget_control,ev.id,set_value = show_valeur                      
        step_lev = float(valeur(0))
        lev_vals=[step_lev] 
        
        p=where(state.ims.imcont_over ne !indef,count)
        if count ne 0 then maxim_cont = max(state.ims.imcont_over(p))
        
        IF defined(min_lev) THEN BEGIN
            n_lev=FIX((maxim-min_lev)/step_lev)
            lev_vals=findgen(n_lev)*step_lev+min_lev
            IF n_lev GT 30 THEN lev_vals=lev_vals(0:29)
        ENDIF
        IF state.var.level_select THEN levels=lev_vals                                                               
    END
    
    "LEVELS" : BEGIN
        IF ev.select THEN BEGIN
            IF defined(lev_vals) THEN BEGIN
                levels=lev_vals
            ENDIF ELSE BEGIN
                levels=0
            ENDELSE
            widget_control,Wlevmin,/sensitive
            widget_control,Wlevstep,/sensitive
            state.var.level_select=1
        ENDIF ELSE BEGIN
            levels=0
            widget_control,Wlevmin,sensitive=0
            widget_control,Wlevstep,sensitive=0
            state.var.level_select=0
        ENDELSE
    END
    
    "GRID" : BEGIN
        IF ev.select THEN BEGIN
            state.var.grid=1
            IF state.var.calcoo EQ 0 THEN BEGIN
                text = 'Creating coordinates ....'
                widget_control,mess,set_value = text
                create_coo2,state.ims.header,coo1,coo2,/silent
                set_state,state,coo1=coo1,coo2=coo2
                coo1=1 & coo2=1
                state.var.calcoo=1
                text = 'Done.'
                widget_control,mess,set_value = text
            ENDIF
        ENDIF ELSE BEGIN
            state.var.grid=0
        ENDELSE
    END
    
    "BAR" : BEGIN
        IF ev.select THEN BEGIN
            bar=1
            state.var.off_bar_pos=[1.2,0.,1.25,1.]
        ENDIF ELSE BEGIN
            bar=0
            state.var.off_bar_pos=0
        ENDELSE
    END
    
    
        
    "FNAME" : BEGIN
        widget_control,ev.id,get_value = state.var.outfile
        text='Filename set to '+string(state.var.outfile)
        widget_control,mess,set_value = text
    END
        
    "RDPIX" : BEGIN
        clic_coo=1
        xrdpix8,state,ev=ev,window_out=Wpix_value, $
                clic_coo=clic_coo,coo1=state.ims.coo1,coo2=state.ims.coo2
;set the zoom center value if clicked
        si=size(clic_coo) & Nel=si(0)
        IF Nel EQ 1 THEN BEGIN
            text = string(clic_coo(0),format='(E9.2)')
            widget_control,Wzoomcent1,set_value = text
            text = string(clic_coo(1),format='(E9.2)')
            widget_control,Wzoomcent2,set_value = text
            state.var.zoom_cent=clic_coo
        ENDIF
    END
    "SCALE" : BEGIN
        state.var.scale_im=ev.value
    END
    
    ELSE   : BEGIN
        print,'Unused event'
    END
    
ENDCASE

widget_control,child1,set_uvalue=state,/no_copy

END

