PRO accept_new_fit_values,state,filter=filter

mess=state.widgets.tex_mess

        coef=state.ims.coef
        fitted=state.ims.to_be_fitted
        si=size(coef) & nncompo=si(1)/3
        Nx=state.var.Nx & Ny=state.var.Ny & Nz=state.var.Nz
        ncompo_max=state.var.ncompo_max
        ;=== resize saving cubes
        IF nncompo GT ncompo_max THEN BEGIN
           all_T=fltarr(Nx,Ny,nncompo+1)+!indef
           all_v=all_T
           all_dv=all_v
           all_T_fitted=intarr(Nx,Ny,nncompo+1)+fix(!indef)
           all_v_fitted=intarr(Nx,Ny,nncompo+1)+fix(!indef)
           all_dv_fitted=intarr(Nx,Ny,nncompo+1)+fix(!indef)
           all_T(*,*,0:ncompo_max)=state.ims.all_T
;           all_v(*,*,0:nncompo-1)=state.ims.all_v
           all_v(*,*,0:ncompo_max)=state.ims.all_v
           all_dv(*,*,0:ncompo_max)=state.ims.all_dv
           all_T_fitted(*,*,0:ncompo_max)=state.ims.all_T_fitted
           all_v_fitted(*,*,0:ncompo_max)=state.ims.all_v_fitted
           all_dv_fitted(*,*,0:ncompo_max)=state.ims.all_dv_fitted
           state.var.ncompo_max=nncompo
           ;Redefine SEE button
           ;STill to be done
        ENDIF ELSE BEGIN
           all_T=state.ims.all_T
           all_v=state.ims.all_v
           all_dv=state.ims.all_dv
           all_T_fitted=state.ims.all_T_fitted
           all_v_fitted=state.ims.all_v_fitted
           all_dv_fitted=state.ims.all_dv_fitted
        ENDELSE
        ;=== Reset the area corresponding to new fit
        all_T(state.var.last_ifit,state.var.last_jfit,*)=!indef
        all_v(state.var.last_ifit,state.var.last_jfit,*)=!indef
        all_dv(state.var.last_ifit,state.var.last_jfit,*)=!indef
        all_T_fitted(state.var.last_ifit,state.var.last_jfit,*)=!indef
        all_v_fitted(state.var.last_ifit,state.var.last_jfit,*)=!indef
        all_dv_fitted(state.var.last_ifit,state.var.last_jfit,*)=!indef
        ;=== Fill in with new data
        FOR i=0,nncompo-1 DO BEGIN
          isok=0
          IF NOT keyword_set(filter) THEN BEGIN
            isok=1
          ENDIF ELSE BEGIN
            dv=coef(3*i+2)
            Tv=coef(3*i)
            IF dv GT 0 AND dv LT 10. AND Tv GT 0 THEN isok=1
          ENDELSE
          IF isok EQ 1 THEN BEGIN
            all_T(state.var.last_ifit,state.var.last_jfit,i)=coef(3*i)
            all_v(state.var.last_ifit,state.var.last_jfit,i)=coef(3*i+1)
            all_dv(state.var.last_ifit,state.var.last_jfit,i)=coef(3*i+2)
            all_T_fitted(state.var.last_ifit,state.var.last_jfit,i)=fitted(3*i)
            all_v_fitted(state.var.last_ifit,state.var.last_jfit,i)=fitted(3*i+1)
            all_dv_fitted(state.var.last_ifit,state.var.last_jfit,i)=fitted(3*i+2)
          ENDIF ELSE BEGIN
            fitted(3*i:3*i+2)=-1
          ENDELSE
        ENDFOR
;        stop
        ;=== update state
        si1=(size(state.ims.all_T))(3) & si2=(size(all_T))(3)
        IF si1 NE si2 THEN BEGIN
          set_state_cube,state,all_T=all_T,all_v=all_v,all_dv=all_dv, $
              all_fitted_T=all_T_fitted,all_fitted_v=all_v_fitted, $
              all_fitted_dv=all_dv_fitted
         ENDIF ELSE BEGIN
              state.ims.all_T=all_T & state.ims.all_v=all_v
              state.ims.all_dv=all_dv
              state.ims.all_T_fitted=all_T_fitted
              state.ims.all_V_fitted=all_v_fitted
              state.ims.all_dv_fitted=all_dv_fitted
         ENDELSE
         
        ;=== Update fixed values for the next fit
        ind=where(fitted NE -1,count)
        IF count NE 0 THEN state.ims.fix_values(ind)=coef(ind)
        ;=== Update the table of fitted parameters
        fit_params=[!indef]
        FOR i=0,state.var.ncompo-1 DO BEGIN
          fit_params=[fit_params,[coef(3*i),coef(3*i+1),coef(3*i+2)]]
        ENDFOR
        fit_params=fit_params(1:*)
;        stop
        update_fit_table,state
        ;=== Check if autosave mode is on
        IF state.var.autosave EQ 1 THEN BEGIN
           widget_control,state.widgets.filename,get_value=filename
           filename=filename(0)
           IF filename NE '' THEN BEGIN
              file=filename
           ENDIF ELSE BEGIN
              file=pickfile(get_path=previous_save_path, $
                      path=state.var.previous_save_path,/write, $
                      filter=state.var.save_filter)
;              stop
              widget_control,state.widgets.filename,set_value=file
              state.var.outfile=file
           ENDELSE
           all_T=state.ims.all_T
           all_v=state.ims.all_v
           all_dv=state.ims.all_dv
           all_T_fitted=state.ims.all_T_fitted
           all_v_fitted=state.ims.all_v_fitted
           all_dv_fitted=state.ims.all_dv_fitted
           header=state.ims.header
           save,all_T,all_v,all_dv,all_T_fitted,all_v_fitted, $
                all_dv_fitted,header,file=file,/xdr
           text = 'File '+file+' written'
           widget_control,mess,set_value = text
        ENDIF
        
        ;=== reset compo slider to initial value
        vv=1
        update_compo_slider,state,vv

        
        END