PRO fit_one_spectrum,state

wset,state.var.window
vel=state.ims.velocity
weight=vel & weight(*)=1.
mess=state.widgets.tex_mess

spec=state.ims.spectrum
coef=state.ims.coef
ncompo=state.var.ncompo
to_be_fit=state.ims.to_be_fitted
niter=50 & chisqr=1.e-10 & silent=1
get_baseline_params,state,baseline_vel,baseline_degree
widget_control,mess,set_value='Fitting Data ...'
res=gaussian_fit(vel,spec,n_component=ncompo,coef=coef, $
                         vrange=state.var.vrange,trange=state.var.trange, $
                         weight=weight,/nonstop, $
                         to_be_fit=to_be_fit, $
                         niter=niter,chisqr=chisqr,silent=silent, $
                         baseline_vel=baseline,baseline_degree=degree)
widget_control,mess,set_value='Updating results ...'
 si1=(size(state.ims.coef))(1) & si2=(size(coef))(1)
 IF si1 NE si2 THEN BEGIN
          set_state_cube,state,coef=coef
 ENDIF ELSE BEGIN
          state.ims.coef=coef
 ENDELSE
 state.var.last_ifit=state.var.ivalue
 state.var.last_jfit=state.var.jvalue
 widget_control,mess,set_value='Done.'

 END