FUNCTION healp2fits_jpb,d,h,hfits

naxis1=sxpar(hfits,'NAXIS1') & naxis2=sxpar(hfits,'NAXIS2')
dfits=fltarr(naxis1,naxis2)
nside=sxpar(h,'NSIDE')
ordering=strtrim(sxpar(h,'ORDERING'),2)

h2pix,hfits,i,j
create_coo2,hfits,c1,c2,/silent
;transform coordinates into that of the healpix file
fitscoo2healp,c1,c2,hfits,h,lon,lat

ang2pix,nside,!pi/2.-lat/!radeg,lon/!radeg,ipix,ordering=ordering

dfits=reform(d(ipix),naxis1,naxis2)

RETURN,dfits

END
