FUNCTION rotate_image,d,h,angle,hout,cut=cut

size_x=abs(sxpar(h,'NAXIS1')*sxpar(h,'CDELT1'))
size_y=abs(sxpar(h,'NAXIS2')*sxpar(h,'CDELT2'))

;new_size_x=size_x*sqrt(2.)
;new_size_y=size_y*sqrt(2.)
new_size=sqrt(size_x^2+size_y^2)
new_size_x=new_size
new_size_y=new_size

size_increase=[new_size_x-size_x,new_size_y-size_y]/2.
;size_max=max([size_x,size_y])*sqrt(2.)

;stop
round=1
;dd=enlarge_image(d,h,[size_max,size_max],hout,round=round)
dd=enlarge_image(d,h,size_increase,hout,round=round)

h2pix,hout,/silent
coo2pix2,sxpar(h,'CRVAL1'),sxpar(h,'CRVAL2'),x0,y0,/silent

mag=1.
dd=rot(dd,angle,mag,x0,y0,/pivot)

IF keyword_set(cut) THEN BEGIN
  dd=cut_image(dd,hout,hout=hhout,/silent)
  hout=hhout
ENDIF

RETURN,dd

END
