FUNCTION NR_gammaq,a,x,itmax=itmax
;From gammaq in Numerical recipes p162

IF X LT 0 OR A LE 0 THEN BEGIN
  print,'NR_gammaq: Error'
  gammq=!indef
  goto,fin
ENDIF
IF x LT A+1 THEN BEGIN
  gammq=1.-nr_gser(a,x,gln,itmax=itmax)
ENDIF ELSE BEGIN
  gammq=nr_gcf(a,x,gln,itmax=itmax)
ENDELSE

fin:

RETURN,gammq

END

