FUNCTION build_connectivity,tr,unique=unique,n_connect=n_connect

Nel=max(tr)+1
Ntr=(size(tr))(2)

con_ptr=ptrarr(Nel)
n_con=lonarr(Nel)

FOR i=0L,Nel-1 DO BEGIN
  ind=where(tr EQ i,c)
  ij=index2ij(ind,[3,Ntr])
  iij=ij(*,1)
;  indexes=[!indef]
;  FOR j=0,c-1 DO BEGIN
;    indexes=[indexes,tr(0,ij(j,1)),tr(1,ij(j,1)),tr(2,ij(j,1))]
;  ENDFOR
;  con_ptr(i)=ptr_new(indexes(1:*))
  con_ptr(i)=ptr_new(reform(tr(*,iij),c*3))  
  IF i mod 1000 EQ 0 THEN print,i,Nel-1 
ENDFOR

IF keyword_set(unique) THEN BEGIN
  message,'Starting Unique ',/info
  FOR i=0L,Nel-1 DO BEGIN
    indexes=*con_ptr(i)
    indexes=indexes(sort(indexes))
    indexes=indexes(uniq(indexes))
    con_ptr(i)=ptr_new(indexes)
    n_con(i)=(size(indexes))(1)
    IF i mod 1000 EQ 0 THEN print,i,Nel-1
  ENDFOR
ENDIF

n_connect=n_con
RETURN,con_ptr

END
