PRO cd2astro,cd11,cd12,cd21,cd22,cdelt1,cdelt2,crota2, $
             lambda=lambda,cdelt1_sign=cdelt1_sign

;assumes cdelt2=-cdelt1 and cdelt1<0
IF not keyword_set(lambda) THEN BEGIN
  lambda=-1.  ;This is cdelt2/cdelt1
ENDIF
IF not keyword_set(cdelt1_sign) THEN BEGIN
  cdelt1_sign=-1.
ENDIF

rho=asin(-1.*cd12/lambda)
IF cd11/cdelt1_sign LT 0. THEN BEGIN
  rho=!pi-rho
ENDIF
crota2=rho*!radeg
crho=cos(rho)

cdelt2=cd22/crho
cdelt1=lambda*cdelt2

END
