FUNCTION ring_index,i,j,naxis1,naxis2,nn,count=count

Np=2*nn+1
i1=lindgen(Np)-nn & j1=lonarr(Np)-nn
i2=i1 & j2=lonarr(Np)+nn

ivalues=[i1,i2,j1(1:Np-2),j2(1:Np-2)]+i
jvalues=[j1,j2,i1(1:Np-2),i2(1:Np-2)]+j

ind=where(ivalues GE 0 AND jvalues GE 0 AND ivalues LE (naxis1-1) $
          AND jvalues LE (naxis2-1),count)

IF count NE 0 THEN BEGIN
  ij=lonarr(count,2)
  ij(*,0)=ivalues(ind)
  ij(*,1)=jvalues(ind)
  index=ij2index(ij,[naxis1,naxis2])
ENDIF ELSE BEGIN
  count=0
  index=-1
ENDELSE

RETURN,index

END