PRO write_pistou_xml,xml_out,strs_in,file=file,lon_center=lon_center,lat_center=lat_center, $
                     min=min,max=max,log=log,x_up=x_up,y_up=y_up,z_up=z_up

lon_def=0.
lat_def=0.
x_def=0.
y_def=0.
z_def=1.
min_def=0.
max_def=1.
scale_def="linear"
IF keyword_set(log) THEN scale="logar" ELSE scale="linear"

strs=strs_in

ind=where(strmatch(strs,'*gen_file*') EQ 1,count)
IF keyword_set(file) THEN BEGIN
  strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_file',file)
ENDIF ELSE BEGIN
  message,'A file has to be given'
ENDELSE
ind=where(strmatch(strs,'*gen_lon*') EQ 1,count)
IF keyword_set(lon_center) THEN BEGIN
  strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_lon',strtrim(lon_center,2))
ENDIF ELSE BEGIN
  strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_lon',strtrim(lon_def,2))
ENDELSE
ind=where(strmatch(strs,'*gen_lat*') EQ 1,count)
IF keyword_set(lat_center) THEN BEGIN
  strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_lat',strtrim(lat_center,2))
ENDIF ELSE BEGIN
  strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_lat',strtrim(lat_def,2))
ENDELSE

ind=where(strmatch(strs,'*gen_x*') EQ 1,count)
IF keyword_set(x_up) THEN BEGIN
  strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_x',strtrim(x_up,2))
ENDIF ELSE BEGIN
  strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_x',strtrim(x_def,2))
ENDELSE
ind=where(strmatch(strs,'*gen_y*') EQ 1,count)
IF keyword_set(y_up) THEN BEGIN
  strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_y',strtrim(y_up,2))
ENDIF ELSE BEGIN
  strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_y',strtrim(y_def,2))
ENDELSE
ind=where(strmatch(strs,'*gen_z*') EQ 1,count)
IF keyword_set(z_up) THEN BEGIN
  strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_z',strtrim(z_up,2))
ENDIF ELSE BEGIN
  strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_z',strtrim(z_def,2))
ENDELSE
ind=where(strmatch(strs,'*gen_min*') EQ 1,count)
IF keyword_set(min) THEN BEGIN
  strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_min',strtrim(min,2))
ENDIF ELSE BEGIN
  strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_min',strtrim(min_def,2))
ENDELSE
ind=where(strmatch(strs,'*gen_max*') EQ 1,count)
IF keyword_set(max) THEN BEGIN
  strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_max',strtrim(max,2))
ENDIF ELSE BEGIN
  strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_max',strtrim(max_def,2))
ENDELSE
ind=where(strmatch(strs,'*gen_scale*') EQ 1,count)
strs(ind(0))=textoidl_str_replace(strs(ind(0)),'gen_scale',scale)

strings2file,strs,xml_out

END
