PRO ang2pix, nside, theta, phi, ipring, ordering=ordering

if N_params() ne 4 then begin
    print,' syntax = ang2pix, nside, theta, phi, ipix [,ordering=]'
    print,'          theta = co-latitude in radians'
    print,'          phi   = longitude in radians'
    goto,sortie
endif

IF not keyword_set(ordering) THEN BEGIN
  sch='RING'
ENDIF ELSE BEGIN
  CASE ordering OF
    'RING': sch='RING'
    'NESTED': sch='NESTED'
    ELSE: BEGIN
      message,'Unknown pixelisation ordering: '+ordering,/info
      message,'Must be either RING or NESTED'
    END
  ENDCASE
ENDELSE

CASE sch of
  'RING': ang2pix_ring, nside, theta, phi, ipring
  'NESTED': ang2pix_nest, nside, theta, phi, ipring
ENDCASE

sortie:

END
