PRO goto_next_spectrum,state,previous=previous,plot=plot

lasti=state.var.ivalue & lastj=state.var.jvalue
ifirst=state.var.ifirst
i=lasti & j=lastj
mess=state.widgets.tex_mess

IF keyword_set(previous) THEN BEGIN
        IF ifirst EQ 1 THEN BEGIN
            IF i-1 LT 0 THEN BEGIN
              IF j-1 LT 0 THEN BEGIN
                widget_control,mess,set_value = 'Already at first spectrum ....'
              ENDIF ELSE BEGIN
                i=state.var.Nx-1 & j=j-1
              ENDELSE
            ENDIF ELSE BEGIN
              i=i-1
            ENDELSE
        ENDIF ELSE BEGIN
            IF j-1 LT 0 THEN BEGIN
              IF i-1 LT 0 THEN BEGIN
                widget_control,mess,set_value = 'Already at first spectrum ....'
              ENDIF ELSE BEGIN
                j=state.var.Ny-1 & i=i-1
              ENDELSE
            ENDIF ELSE BEGIN
              j=j-1
            ENDELSE
        ENDELSE

ENDIF ELSE BEGIN
        IF ifirst EQ 1 THEN BEGIN
            IF i+1 GT state.var.Nx-1 THEN BEGIN
              IF j+1 GT state.var.Ny-1 THEN BEGIN
                widget_control,mess,set_value = 'Already at last spectrum ....'
              ENDIF ELSE BEGIN
                i=0 & j=j+1
              ENDELSE
            ENDIF ELSE BEGIN
              i=i+1
            ENDELSE
        ENDIF ELSE BEGIN
            IF j+1 GT state.var.Ny-1 THEN BEGIN
              IF i+1 GT state.var.Nx-1 THEN BEGIN
                widget_control,mess,set_value = 'Already at last spectrum ....'
              ENDIF ELSE BEGIN
                j=0 & i=i+1
              ENDELSE
            ENDIF ELSE BEGIN
              j=j+1
            ENDELSE
        ENDELSE
ENDELSE
state.var.ivalue=i
state.var.jvalue=j
IF state.var.fromref EQ 1 THEN BEGIN
         get_ref_values,state
ENDIF
widget_control,state.widgets.islider,set_value=state.var.ivalue
widget_control,state.widgets.jslider,set_value=state.var.jvalue
spec=reform(state.ims.cube(state.var.ivalue,state.var.jvalue,*))
state.ims.spectrum=spec
update_state_range,state
;compute previous fit parameters, if they exist
get_fit_params,state,fit_params
get_baseline_params,state,baseline_vel,baseline_degree

IF keyword_set(plot) THEN BEGIN
        wset,state.var.window
        widget_control,mess,set_value = 'Plotting Spectrum ...'
        plot_fit_spec,state.ims.velocity,state.ims.spectrum, $
                      vrange=state.var.vrange,trange=state.var.trange, $
                      rebin=state.var.rebin,fit_params=fit_params, $
                      show_vel=state.ims.baseline,baseline_vel=baseline_vel, $
                      baseline_degree=baseline_degree
        widget_control,mess,set_value = 'Done.'             
ENDIF

;reset compo slider to initial value
vv=1
update_compo_slider,state,vv
;=== Update the table of fitted parameters
update_fit_table,state

END
