PRO set_state_cube,state,cube=cube,header=header,spectrum=spectrum, $
                velocity=velocity,coef=coef, $
                all_T=all_T,all_dv=all_dv,all_v=all_v, $
                all_fitted_T=all_fitted_T,all_fitted_dv=all_fitted_dv, $
                all_fitted_v=all_fitted_v, $
                already_fitted=already_fitted,to_be_fitted=to_be_fitted, $
                fix_values=fix_values,baseline=baseline, $
                Rall_T=Rall_T,Rall_dv=Rall_dv,Rall_v=Rall_v, $
                Rall_fitted_T=Rall_fitted_T,Rall_fitted_dv=Rall_fitted_dv, $
                Rall_fitted_v=Rall_fitted_v,Rheader=Rheader, $
                coo1=coo1,coo2=coo2,Rcoo1=Rcoo1,Rcoo2=Rcoo2

;IF keyword_set(cube) THEN cube1=cube ELSE cube1=state.ims.cube
IF keyword_set(header) THEN header1=header ELSE header1=state.ims.header
IF keyword_set(spectrum) THEN spectrum1=spectrum ELSE $
                              spectrum1=state.ims.spectrum
IF keyword_set(velocity) THEN velocity1=velocity ELSE $
                              velocity1=state.ims.velocity
IF keyword_set(coef) THEN coef1=coef ELSE $
                              coef1=state.ims.coef
IF keyword_set(all_T) THEN all_T1=all_T ELSE $
                              all_T1=state.ims.all_T
IF keyword_set(all_v) THEN all_v1=all_v ELSE $
                              all_v1=state.ims.all_v
IF keyword_set(all_dv) THEN all_dv1=all_dv ELSE $
                              all_dv1=state.ims.all_dv
IF keyword_set(all_fitted_T) THEN all_T_fitted1=all_fitted_T ELSE $
                              all_T_fitted1=state.ims.all_T_fitted
IF keyword_set(all_fitted_v) THEN all_v_fitted1=all_fitted_v ELSE $
                              all_v_fitted1=state.ims.all_v_fitted
IF keyword_set(all_fitted_dv) THEN all_dv_fitted1=all_fitted_dv ELSE $
                              all_dv_fitted1=state.ims.all_dv_fitted
IF keyword_set(already_fitted) THEN already_fitted1=already_fitted ELSE $
                              already_fitted1=state.ims.already_fitted
IF keyword_set(to_be_fitted) THEN to_be_fitted1=to_be_fitted ELSE $
                              to_be_fitted1=state.ims.to_be_fitted
IF keyword_set(fix_values) THEN fix_values1=fix_values ELSE $
                              fix_values1=state.ims.fix_values
IF keyword_set(baseline) THEN baseline1=baseline ELSE $
                              baseline1=state.ims.baseline
IF keyword_set(Rheader) THEN header_R1=Rheader ELSE  $
                              header_R1=state.ims.header_R
IF keyword_set(Rall_T) THEN all_T_R1=Rall_T ELSE $
                              all_T_R1=state.ims.all_T_R
IF keyword_set(Rall_v) THEN all_v_R1=Rall_v ELSE $
                              all_v_R1=state.ims.all_v_R
IF keyword_set(Rall_dv) THEN all_dv_R1=Rall_dv ELSE $
                              all_dv_R1=state.ims.all_dv_R
IF keyword_set(Rall_fitted_T) THEN all_T_fitted_R1=Rall_fitted_T ELSE $
                              all_T_fitted_R1=state.ims.all_T_fitted_R
IF keyword_set(Rall_fitted_v) THEN all_v_fitted_R1=Rall_fitted_v ELSE $
                              all_v_fitted_R1=state.ims.all_v_fitted_R
IF keyword_set(Rall_fitted_dv) THEN all_dv_fitted_R1=Rall_fitted_dv ELSE $
                              all_dv_fitted_R1=state.ims.all_dv_fitted_R
IF keyword_set(Coo1) THEN coo1_1=coo1 ELSE $
                              coo1_1=state.ims.coo1
IF keyword_set(Coo2) THEN coo2_1=coo2 ELSE $
                              coo2_1=state.ims.coo2
IF keyword_set(RCoo1) THEN Rcoo1_1=Rcoo1 ELSE $
                              Rcoo1_1=state.ims.coo1_ref
IF keyword_set(RCoo2) THEN Rcoo2_1=Rcoo2 ELSE $
                              Rcoo2_1=state.ims.coo2_ref

IF keyword_set(cube) THEN BEGIN
  im_state={cube:cube,header:header1, $
         spectrum:spectrum1,velocity:velocity1,coef:coef1, $
         all_T:all_T1,all_v:all_v1,all_dv:all_dv1, $
         all_T_fitted:all_T_fitted1,all_v_fitted:all_v_fitted1, $
         all_dv_fitted:all_dv_fitted1, $
         already_fitted:already_fitted1,to_be_fitted:to_be_fitted1, $
         fix_values:fix_values1,baseline:baseline1,header_R:header_R1, $
         all_T_R:all_T_R1,all_v_R:all_v_R1,all_dv_R:all_dv_R1, $
         all_T_fitted_R:all_T_fitted_R1,all_v_fitted_R:all_v_fitted_R1, $
         all_dv_fitted_R:all_dv_fitted_R1, $
         coo1:coo1_1,coo2:coo2_1,coo1_ref:Rcoo1_1,coo2_ref:Rcoo2_1}
ENDIF ELSE BEGIN
  im_state={cube:state.ims.cube,header:header1, $
         spectrum:spectrum1,velocity:velocity1,coef:coef1, $
         all_T:all_T1,all_v:all_v1,all_dv:all_dv1, $
         all_T_fitted:all_T_fitted1,all_v_fitted:all_v_fitted1, $
         all_dv_fitted:all_dv_fitted1, $
         already_fitted:already_fitted1,to_be_fitted:to_be_fitted1, $
         fix_values:fix_values1,baseline:baseline1,header_R:header_R1, $
         all_T_R:all_T_R1,all_v_R:all_v_R1,all_dv_R:all_dv_R1, $
         all_T_fitted_R:all_T_fitted_R1,all_v_fitted_R:all_v_fitted_R1, $
         all_dv_fitted_R:all_dv_fitted_R1, $
         coo1:coo1_1,coo2:coo2_1,coo1_ref:Rcoo1_1,coo2_ref:Rcoo2_1}
ENDELSE

state={widgets:state.widgets,var:state.var,ims:im_state}
help,state.ims,/str

END
