PRO update_fit_table,state,fit_params

;stop
;ncompo=(size(fit_params))(1)/3
i=state.var.ivalue & j=state.var.jvalue
ind=where(state.ims.all_T(i,j,*) NE !indef,ncompo)
;print,state.ims.all_V_fitted(i,j,*)

;=== Update the table of fitted parameters
Nmax_tab=9
Npar=3
vv=strarr(Npar,Nmax_tab) & vv(*,*)='---'

IF ncompo NE 0 THEN BEGIN
   FOR ii=0,ncompo-1 DO BEGIN
        vv(0,ii)=string(strtrim(state.ims.all_T(i,j,ind(ii)),2), $
                        format=state.var.frmt3)
        IF state.ims.all_T_fitted(i,j,ind(ii)) EQ 0 THEN BEGIN
            vv(0,ii)='*'+vv(0,ii)
        ENDIF
        vv(1,ii)=string(strtrim(state.ims.all_V(i,j,ind(ii)),2), $
                 format=state.var.frmt3)
        IF state.ims.all_V_fitted(i,j,ind(ii)) EQ 0 THEN BEGIN
            vv(1,ii)='*'+vv(1,ii)
        ENDIF
        vv(2,ii)=string(strtrim(state.ims.all_dV(i,j,ind(ii)),2), $
                        format=state.var.frmt3)
        IF state.ims.all_dV_fitted(i,j,ind(ii)) EQ 0 THEN BEGIN
            vv(2,ii)='*'+vv(2,ii)
        ENDIF
       
;      FOR par=0,Npar-1 DO BEGIN
;        vv(par,ii)=string(strtrim([fit_params(3*ii), $
;                            fit_params(3*ii+1),fit_params(3*ii+2)],2), $
;                            format=state.var.frmt3)
   ENDFOR
ENDIF

widget_control,state.widgets.bestfit,set_value=vv,set_table_select=[0,0,2,8]
widget_control,state.widgets.bestfit,set_table_select=[0,0,0,0]

 END
