PRO remove_tmp_files

;+
; NAME:
;       remove_tmp_files
; CALLING SEQUENCE:
;       remove_tmp_files
; PURPOSE:
;       Remove temporary files on Macintosh
; INPUTS:
;       None
; OPTIONAL INPUT:
;       None
; OUTPUTS:
;	   None
; PROCEDURE AND SUBROUTINE USED
;       do_apple_script
; SIDE EFFECTS:
;       temp_* files in the temporary area are transfered to trash
; MODIFICATION HISTORY:
;       written by Jean-Philippe Bernard 29-Aug-98 @ IAS
; EXAMPLE:
;-

IF !version .os NE 'MacOS' THEN BEGIN
  GOTO,sortie
ENDIF

path_tmp=filepath('',/tmp)
files=findfile(path_tmp+'temp_*',count=count)
pos=strposmulti(path_tmp,':',Npos)
str_path=' of startup disk'
FOR i=0,Npos-2 DO BEGIN
  str_path=' of folder "'+strmid(path_tmp,pos(i)+1,pos(i+1)-pos(i)-1)+'"'+str_path
ENDFOR

IF count NE 0 THEN BEGIN
  script=['tell application "Finder"']
;  script=[script,'activate']
  sel_str='select {file '
  FOR i=0,count-1 DO BEGIN
    sel_str=sel_str+'"'+strmid(files(i),pos(Npos-1)+1,strlen(files(i)))+'"'+str_path
    IF i EQ count-1 THEN BEGIN
      sel_str=sel_str+'}'
    ENDIF ELSE BEGIN
      sel_str=sel_str+', file '
    ENDELSE
  ENDFOR
  script=[script,sel_str]
  script=[script,'delete selection']
  script=[script,'end tell']
  do_apple_script,script
ENDIF

sortie:

END