FUNCTION nr_gcf,a,x,gln,itmax=itmax

;From Numerical Recipies GCF p162

IF not keyword_set(itmax) THEN itm=100 ELSE itm=itmax
eps=3.e-7
;gln=alog(gamma(a))
gln=lngamma(a)

gold=0. & A0=1. & A1=X & B0=0. & B1=1. & Fac=1.
FOR N=1,itm DO BEGIN
  ana=1.*N-A
  A0=(A1+A0*ana)*fac
  B0=(B1+B0*ana)*fac
  anf=1.*N*fac
  A1=x*A0+anf*A1
  B1=x*B0+anf*B1
  IF A1 NE 0 THEN BEGIN
    FAC=1./A1
    G=B1*fac
    IF abs((g-gold)/g) LT eps THEN goto,fin
    gold=g
  ENDIF
ENDFOR

print,'NR_gcf: Error A too large, itmax too small'
RETURN,!indef

fin:
gammcf=exp(-x+a*alog(x)-gln)*g

RETURN,gammcf

END

