FUNCTION nr_gser,a,x,gln,itmax=itmax

;From Numerical recipes gser p162

IF not keyword_set(itmax) THEN itm=100 ELSE itm=itmax
;itmax=10000
eps=3.e-7

;gln=alog(gamma(a))
gln=lngamma(a)

IF x LE 0 THEN BEGIN
  IF x LT 0 THEN BEGIN
    gamser=0.
    goto,fin
  ENDIF
ENDIF
Ap=A
sum=1./a
del=sum
FOR N=1,itm DO BEGIN
  ap=ap+1.
  del=del*X/AP
  sum=sum+del
  IF abs(del)  LT abs(sum)*eps THEN goto,fin
ENDFOR

print,'NR_gser: Error A too large, itmax too small'
RETURN,!indef

fin:
gamser=sum*exp(-x+a*alog(x)-gln)

RETURN,gamser

END
